// Min Vista/Server 2008
#define _WIN32_WINNT 0x0600
#include <windows.h>
#include <stdio.h>

// Global variable
INIT_ONCE g_InitOnce;

BOOL CALLBACK InitHandleFunction (
    PINIT_ONCE InitOnce,
    PVOID Parameter,
    PVOID *lpContext)
{
  HANDLE hEvent;

  hEvent = CreateEvent(NULL, TRUE, TRUE, NULL);

  if (NULL == hEvent)
  {
	  wprintf(L"CreateEvent() failed, error %d\n", GetLastError());
	  return FALSE;
  }
  else
  {
	  wprintf(L"CreateEvent() is OK\n");
	  *lpContext = hEvent;
	  return TRUE;
  }
}

HANDLE OpenEventHandleSync()
{
  PVOID lpContext;
  BOOL  bStatus;
  
  bStatus = InitOnceExecuteOnce(&g_InitOnce, InitHandleFunction, NULL, &lpContext);

  if (bStatus)
  {
	  wprintf(L"InitOnceExecuteOnce() is OK...\n");
	  return (HANDLE)lpContext;
  }
  else
  {
	  wprintf(L"InitOnceExecuteOnce() failed, error %d\n", GetLastError());
	  return (INVALID_HANDLE_VALUE);
  }
}

int wmain()
{
	OpenEventHandleSync();
	return 0;
}